//
//  NSString-P3CExtensions.h
//  P3CCocoaExtensions
//
//  Created by Pascal on Mon Mar 04 2002.
//  Copyright (c) 2002 P3 Consulting. All rights reserved.
//
/*
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import <Cocoa/Cocoa.h>

@interface NSString(P3TrimString)
-(NSString *) trim;
@end

@interface NSString(P3SupprSpaceString)
-(NSString *) supprspace;
@end

@interface NSString(P3EscapeForHTML)
-(NSString *) escapeStringForHTML;
-(NSString *) unescapeStringFromHTML;
@end

@interface NSString(P3EscapeForSQL)
-(NSString *) escapeStringForSQL;
-(NSString *) unescapeStringFromSQL;
@end

@interface NSString(P3EscapeForC)
-(NSString *) escapeStringForC;
-(NSString *) unescapeStringFromC;
@end

@interface NSString(UTF8length)
-(int) UTF8length;
@end

@interface NSString(P3EscapeForXML)
-(NSString *) escapeStringForXML;
@end

@interface NSString(ABUtils)
-(NSString *) extractABLabel;
@end

@interface NSString(RFC2396Support)
-(NSString *) stringByAddingPercentEscapes;
-(NSString *) stringByReplacingPercentEscapes;
@end

@interface NSString(ReadLine)
- (NSArray *) readFieldsForSeparator:(NSString *)fieldSep lineEndIndex:(unsigned *)lineEndIndex;
@end

@interface NSString(TabExport)
- (BOOL)containsString:(NSString *)searchString options:(unsigned int)mask;
- (BOOL)containsString:(NSString *)searchString;
- (NSString *)stringByReplacingReturns:(NSString *)byString;
- (NSString *)stringByReplacingString:(NSString *)removeString by:(NSString *)byString;
@end


@interface NSString(ParseACL)
-(NSDictionary *)parseACL;
+(NSString *)fromACLDict:(NSDictionary *)inDict;
@end

@interface NSString(P3ParseIntArray)
-(NSArray *)parseIntArray;
+(NSString *)fromIntArray:(NSArray *)inArray;
+(NSString *)fromIntArray:(NSArray *)inArray startList:(NSString *)inStart endList:(NSString *)inEnd;
@end

@interface NSString(P3ParseLongLongArray)
-(NSArray *)parseLongLongArray;
+(NSString *)fromLongLongArray:(NSArray *)inArray;
+(NSString *)fromLongLongArray:(NSArray *)inArray startList:(NSString *)inStart endList:(NSString *)inEnd;
@end

@interface NSString(Dictionary)
-(NSDictionary *) asDictionary;
@end

@interface NSString (NSStringTextFinding)
- (NSRange)findString:(NSString *)string selectedRange:(NSRange)selectedRange options:(unsigned)options wrap:(BOOL)wrap;
@end

@interface NSString(BoolValue)
- (BOOL)boolValue;
@end

@interface NSString(Quote)
- (NSString *)quote;
@end

